> For the complete documentation index, see [llms.txt](https://docs.neuralens.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.neuralens.ai/reference/api-reference.md).

# API Reference

Dive into the specifics of each API endpoint by checking out our complete documentation.

## Indexing

Indexing is how you add your products to the search engine.

{% content-ref url="/pages/YPkLgsN7B75ucoTuEFRQ" %}
[Indexing](/reference/api-reference/indexing.md)
{% endcontent-ref %}

## Search

Use the Search API to query the indexed products.

{% content-ref url="/pages/nyFhqw1VFyeCgz9Vacee" %}
[Search](/reference/api-reference/search.md)
{% endcontent-ref %}

## Autocomplete

The Autocomplete API returns suggestions for the autocompleter.

{% content-ref url="/pages/KgP5r4KxAiCf4diCcfNO" %}
[Autocomplete](/reference/api-reference/autocomplete.md)
{% endcontent-ref %}

## Event Tracking

Event Tracking allows Neuralens to learn from a user's behaviour and personalise the results for them.

{% content-ref url="/pages/WO5mz8GCqOIMR2AGd3EI" %}
[Event tracking](/reference/api-reference/event-tracking.md)
{% endcontent-ref %}

##


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.neuralens.ai/reference/api-reference.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
